package uy.edu.fing.tse.jsf;

import uy.edu.fing.tse.central.business.BusinessLocal;
import uy.edu.fing.tse.dto.Fact;
import uy.edu.fing.tse.dto.State;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.enterprise.context.RequestScoped;
import javax.inject.Named;
import java.io.Serializable;
import java.util.List;

@RequestScoped
@Named("gestionHechos")
public class GestionHechosBean implements Serializable {

    private static final long serialVersionUID = 9142442208455999158L;

    @EJB
    private BusinessLocal service;

    @PostConstruct
    public void init() {
        estados = service.listarEstados();
        filteredFacts = service.listarHechos();
    }

    private List<State> estados;

    private List<Fact> filteredFacts;

    private String filterTitulo = "";
    private String filterDesc = "";
    private String filterEstado = "";


    public List<Fact> getFilteredFacts() {
        return filteredFacts;
    }

    public void setFilteredFacts(List<Fact> filteredFacts) {
        this.filteredFacts = filteredFacts;
    }

    public List<State> getEstados() {
        return estados;
    }

    public String getFilterTitulo() {
        return filterTitulo;
    }

    public void setFilterTitulo(String filterTitulo) {
        this.filterTitulo = filterTitulo;
    }

    public String getFilterDesc() {
        return filterDesc;
    }

    public void setFilterDesc(String filterDesc) {
        this.filterDesc = filterDesc;
    }

    public String getFilterEstado() {
        return filterEstado;
    }

    public void setFilterEstado(String filterEstado) {
        this.filterEstado = filterEstado;
    }
}

