package uy.edu.fing.tse.jsf;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import uy.edu.fing.tse.central.business.BusinessLocal;
import uy.edu.fing.tse.central.business.security.SecurityLocal;
import uy.edu.fing.tse.dto.Role;
import uy.edu.fing.tse.dto.UserBO;
import uy.edu.fing.tse.jsf.session.SessionBean;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.enterprise.context.RequestScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;
import java.io.Serializable;
import java.util.List;

@RequestScoped
@Named("userLoginView")
public class UserLoginBean implements Serializable {

    private static final long serialVersionUID = -7674319505640122631L;

    private static final Logger LOG = LoggerFactory.getLogger(UserLoginBean.class);
    @EJB
    private SecurityLocal securityLocal;

    @EJB
    private BusinessLocal negocio;

    @Inject
    private SessionBean session;

    private List<Role> roles;

    @PostConstruct
    public void init() {
        roles = negocio.listarRoles();
    }

    final UserBO user = new UserBO();

    private String repassword;

    public List<Role> getRoles() {
        return roles;
    }

    public void setRoles(List<Role> roles) {
        this.roles = roles;
    }

    public UserBO getUser() {
        return user;
    }

    public String getRepassword() {
        return repassword;
    }

    public void setRepassword(String repassword) {
        this.repassword = repassword;
    }

    public String login() {
        String token = securityLocal.login(user);

        if (token != null) {
            session.setToken(token);
            session.setUser(user);
            return "jsf/gestionhechos";
        } else {
            FacesContext.getCurrentInstance().addMessage(
                    null,
                    new FacesMessage(FacesMessage.SEVERITY_WARN,
                            "Ingreso Incorrecto",
                            "Por favor verificar los datos ingresados"));
        }
        return "";
    }

    public String register() {
        boolean valid = true;

        // verificar que sean iguales la pasw, en caso contrario
        valid &= user.getPassword().equals(repassword);
        //Verificar que no existe usuario
        //TODO
        if (valid) {
            final var s = securityLocal.register(user);
            return "jsf/gestionhechos";
        } else {
            FacesContext.getCurrentInstance().addMessage(
                    null,
                    new FacesMessage(FacesMessage.SEVERITY_WARN,
                            " Usuario o Password diferentes",
                            "Por favor verificar los datos ingresados"));
            return "";
        }
    }

}
