package uy.edu.fing.tse.jsf.security;

import io.jsonwebtoken.Claims;
import io.jsonwebtoken.Jwts;
import uy.edu.fing.tse.jsf.session.SessionBean;

import javax.inject.Inject;
import javax.servlet.*;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

@WebFilter("/jsf/*")
public class JwtFilter implements javax.servlet.Filter {

    @Inject
    private SessionBean session;

    @Override
    public void init(FilterConfig filterConfig) throws ServletException {

    }

    @Override
    public void doFilter(ServletRequest req, ServletResponse res, FilterChain chain) throws IOException, ServletException {
        final HttpServletRequest request = (HttpServletRequest) req;
        final HttpServletResponse response = (HttpServletResponse) res;

        final var token = session.getToken();
        if (token == null) {
            //TODO se puede hacer un send Redirect para enviarlo al Login
            response.setStatus(401);
            response.sendRedirect(request.getContextPath() + "/login.xhtml");
            return;
        }

        try {
            final Claims claims = Jwts.parser().setSigningKey("1q2w3e4r5t6y7u8i9o0p").parseClaimsJws(token).getBody();
            request.setAttribute("claims", claims);
        } catch (final Exception e) {
            session.invalidate();
            response.setStatus(401);
            return;
        }

        chain.doFilter(req, res);
    }

    @Override
    public void destroy() {
    }
}
