package uy.edu.fing.tse.jsf.session;

import uy.edu.fing.tse.dto.UserBO;

import javax.enterprise.context.SessionScoped;
import javax.inject.Named;
import java.io.Serializable;

@SessionScoped
@Named("sessionBean")
public class SessionBean implements Serializable {

    private static final long serialVersionUID = 9062153372176877309L;

    private String token = null;

    private UserBO user = null;

    public String getToken() {
        return token;
    }

    public void setToken(String token) {
        this.token = token;
    }

    public UserBO getUser() {
        return user;
    }

    public void setUser(UserBO user) {
        this.user = user;
    }

    public String makeToken() {
        if (token == null) {
            return null;
        }
        return "Bearer " + token;
    }

    public void invalidate() {
        token = null;
        user = null;
    }
}
